#ifndef API_AUTHOR_HPP_
#define API_AUTHOR_HPP_
#include <includes.h>
#include <net.h>
using std::string, std::cout, std::endl, nlohmann::json;
class Author {
private:
    json data;
    WebSocket& web;
    NetworkManager& req;
public:
    Author(const json& data) : data(data), web(WebSocket::getInstance()), req(NetworkManager::getInstance()) {}
    string content() {
        try {
            return data["d"]["content"];
        }
        catch (...) {
            return "";
        }
    }
    string channel_id() {
        return data["d"]["channel_id"];
    }
    string id() {
        return data["d"]["author"]["id"];
    }
    string global_name() {
        return data["d"]["author"]["global_name"].dump();
    }
    string discriminator() {
        return data["d"]["author"]["discriminator"];
    }
    bool isBot() {
        try {
            return data["d"]["author"]["bot"];
        }
        catch (...) {
            return 0;
        }
    }
    string guild_id() {
        return data["d"]["guild_id"];
    }
    string msg_id() {
        return data["d"]["id"];
    }
    bool isPinned() {
        return data["d"]["pinned"];
    }
    string avatar() {
        return data["d"]["author"]["avatar"];
    }
    string send(const json& msg) {
        return req.request(HttpMethods::POST, DiscordEndpoints::details::latest + "/channels/" + data["d"]["channel_id"].get<string>() + "/messages", msg.dump());
    }
};
#endif