#ifndef API_BOT_HPP_
#define API_BOT_HPP_
#include <includes.h>
using std::string, std::cout, std::endl, nlohmann::json;
template<typename...Args>
class Discord {
private:
    void initializeNets(const json& data) {
        initializeNetsImpl(data, std::index_sequence_for<Args...>{});
    }
    template<unsigned long... Is>
    void initializeNetsImpl(const json& data, std::index_sequence<Is...>) {
        net = std::make_tuple(std::make_unique<Args>(data)...);
    }
    json data;
public:
    std::tuple<std::unique_ptr<Args>...> net;
    Discord(const json& data) : data(data) {
        initializeNets(data);
    }
};
class Bot {
private:
    json data;
public:
    Bot(const json& data) : data(data) {};
    string id() {
        return data["d"]["id"];
    }
    bool isBot() {
        try {
            return data["d"]["bot"];
        }
        catch (...) {
            return false;
        }
    }
};
#endif